#include "RainDrop128256.h"

static void RainDropGenRK_128_256(u8i * Rk,const u8i * K,int dirt);
static void  RainDrop128256EncDataS_Round(u8i *out, u8i *cp, u8i *K,int round);

//ֻּӽ
//ӽԿ洢ռ䲻ͬ
//ܣ  RoundRainDrop128256*8
//ܣ  RoundRainDrop128256*128
void Key_Schedule(unsigned char *Seedkey, int KeyLen, unsigned   char Direction, unsigned char *Subkey)
{
	if (Direction == Dirt_ENC)
		RainDropGenRK_128_256_ENC(Subkey, Seedkey);
	else
		RainDropGenRK_128_256M_DEC(Subkey, Seedkey);
	//RainDropGenRK_128_128(Subkey, Seedkey,Direction); 
}
int Crypt_Enc_Block_Round(unsigned char *input,int in_len,  unsigned char *output, int *out_len, unsigned char *key, int keylen, int CryptRound)
{
	u8i _C_ALIGN16( rk[RoundRainDrop128256*8]); 
	int i;
	if(in_len<1)
		return -1;
	if(keylen!=32)
		return -2;
	if((CryptRound> RoundRainDrop128256) || (CryptRound<0))
		return -3;  
	RainDropGenRK_128_256(rk, key,Dirt_ENC); 
	for(i=0;i<in_len;i+=16)
		RainDrop128256EncDataS_Round(output+i, input+i, rk, CryptRound);
	printf(" round   %03d : ",CryptRound);
	for(i=0;i<16;i++)
	{
		printf("%02X", output[i]);
		if(i==7) 
			printf(" ");
	}
	printf(" rk%03d : ",CryptRound);
	for(i=0;i<8;i++)
      printf("%02X", rk[CryptRound*8+i-8]);
	printf("\n");
	*out_len= in_len;
	return 0; 
} 

int Crypt_Enc_Block(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u8i _C_ALIGN16(rk[RoundRainDrop128256 * 8]);
	int i;
	if (in_len < 1)
		return -1;
	if (in_len & 0x0f)
		return -2;
	if (keylen != 32)
		return -3;
	RainDropGenRK_128_256_ENC(rk, key);
	for (i = 0; i < in_len; i += 16)
		RainDrop128256EncDataS(output + i, input + i, rk);

	*out_len = in_len;
	return 0;
}
int Crypt_Dec_Block(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u8i TText[256];
	__m256i rksimd[RoundRainDrop128256 * 4];
	int i, leftbytes;
	if (in_len < 1)
		return -1;
	if (in_len & 0x0f)
		return -2;
	if (keylen != 32)
		return -3;
	RainDropGenRK_128_256M_DEC(rksimd, key);
	leftbytes = in_len;
	while (leftbytes >= 256)
	{
		RainDrop128256EncDataM(output, input, (u8i *)rksimd);
		output += 256;
		input += 256;
		leftbytes -= 256;
	}
	if (leftbytes)
	{
		memcpy(TText, input, leftbytes);
		RainDrop128256EncDataM(TText, TText, (u8i *)rksimd);
		memcpy(output, TText, leftbytes);
	}
	*out_len = in_len;
	return 0;
}

//IV ȫ 0

int Crypt_Enc_Block_CBC(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u8i _C_ALIGN16(rk[RoundRainDrop128256 * 8]);
	u64i _C_ALIGN16(IV[2]);
	int i, j;
	if (in_len < 1)
		return -1;
	if (in_len & 0x0f)
		return -2;
	if (keylen != 32)
		return -3;
	RainDropGenRK_128_256_ENC(rk, key);
	RainDrop128256EncDataS(output, input, rk);
	for (i = 16; i < in_len; i += 16)
	{
		IV[0] = (*(u64i *)(input + i)) ^ (*(u64i *)(output + i - 16));
		IV[1] = (*(u64i *)(input + i + 8)) ^ (*(u64i *)(output + i - 8));
		RainDrop128256EncDataS(output + i, (u8i *)IV, rk);
	}
	*out_len = in_len;
	return 0;
}
int Crypt_Dec_Block_CBC(unsigned char *input, int in_len, unsigned char  *output, int *out_len, unsigned char *key, int keylen)
{
	u8i _C_ALIGN16(TText[256]);
	__m256i rksimd[RoundRainDrop128256 * 4];
	__m128i mIV = _mm_set1_epi64x(0);
	int i, leftbytes;
	if (in_len < 1)
		return -1;
	if (in_len & 0x0f)
		return -2;
	if (keylen != 32)
		return -3;
	RainDropGenRK_128_256M_DEC(rksimd, key);
	leftbytes = in_len;
	while (leftbytes >= 256)
	{
		RainDrop128256EncDataM_CBC(output, input, rksimd, &mIV);
		output += 256;
		input += 256;
		leftbytes -= 256;
	}
	if (leftbytes)
	{
		memcpy(TText, input, leftbytes);
		RainDrop128256EncDataM_CBC(TText, TText, rksimd, &mIV);
		memcpy(output, TText, leftbytes);
	}
	*out_len = in_len;
	return 0;
}

static void RainDropGenRK_128_256(u8i * Rk,const u8i * K,int dirt)
{ 
	u32i tmp;  	 
		u32i e0,e1,e2,e3,e4,e5,e6,e7,t0,t2; 
	u32i T0,T1,T2,T3,T4,T5,T6,T7;		
	u16i *p= (u16i *)Rk; 
	u32i i; 
	T0= SWAP32( *((u32i *) K));
	T1= SWAP32( *((u32i *) (K+4)));
	T2= SWAP32( *((u32i *) (K+8)));
	T3= SWAP32( *((u32i *) (K+12)));
	T4= SWAP32( *((u32i *) (K+16)));
	T5= SWAP32( *((u32i *) (K+20)));
	T6= SWAP32( *((u32i *) (K+24)));
	T7= SWAP32( *((u32i *) (K+28))); 
	if(dirt== Dirt_ENC)
	{
		*p =   SWAP16(T0>>16); 
		*(p+1) =  SWAP16(T1>>16);
		*(p+2) =  SWAP16(T2>>16);
		*(p+3) =  SWAP16(T3>>16);   
		p+=4;  
		for( i=1;i< RoundRainDrop128256;i++)  
		{ 	   
			T2^=i;  
		 Fun_A(T,13,19,tmp);  
		Fun_A(T,13,19,tmp);   
		 Fun_A(T,13,19,tmp);  
		Fun_A(T,13,19,tmp);      
			*p =   SWAP16(T0>>16); 
			*(p+1) =  SWAP16(T1>>16);
			*(p+2) =  SWAP16(T2>>16);
			*(p+3) =  SWAP16(T3>>16);    
			p+=4; 
		}
	}
	else
	{
		p+= (RoundRainDrop128256*4)-1;
		*p =   SWAP16(T3>>16); 
		*(p-1) =  SWAP16(T2>>16);
		*(p-2) =  SWAP16(T1>>16);
		*(p-3) =  SWAP16(T0>>16);   
		p-=4; 

		for( i=1;i< RoundRainDrop128256;i++)  
		{ 	   
			T2^=i;  
		 Fun_A(T,13,19,tmp);  
		Fun_A(T,13,19,tmp);   
		 Fun_A(T,13,19,tmp);  
		Fun_A(T,13,19,tmp);   
		*p =   SWAP16(T3>>16); 
		*(p-1) =  SWAP16(T2>>16);
		*(p-2) =  SWAP16(T1>>16);
		*(p-3) =  SWAP16(T0>>16);    
			p-=4; 
		} 
	}  
}



static void SingleRoundRainDrop128256(u16i *in,u16i *rk)
{ 
	u16i l0,l1,l2,l3;
	u16i r0,r1,r2,r3;  
	u16i k0,k1,k2,k3;
	u16i t0,t1,t2,t3,t4,t5;
	l0=(*in);
	l1=*(in+1);
	l2=*(in+2);
	l3=*(in+3);
	r0=*(in);
	r1=*(in+1);
	r2=*(in+2);
	r3=*(in+3);   
	Sbox35(l0);
	Sbox35(l1);
	Sbox35(l2);
	Sbox35(l3); 

	k0= l1^l3; 
	k1= ROTL16(l2^l3,6);    
	k2= ROTL16(l0,7);
	k3= ROTL16(l0^l1,12);  

	l0=k0^(SWAP16(*(rk)) );
	l1=k1^(SWAP16(*(rk+1)) );
	l2=k2^(SWAP16(*(rk+2)) );
	l3=k3^(SWAP16(*(rk+3)) ); 
	(*in)=l0^(*(in+4));
	*(in+1)=l1^(*(in+5));
	*(in+2)=l2^(*(in+6));
	*(in+3)=l3^(*(in+7));   
	*(in+4)=r0;
	*(in+5)=r1;
	*(in+6)=r2;
	*(in+7)=r3;      

} 


static void  RainDrop128256EncDataS_Round(u8i *out, u8i *cp, u8i *rk,int round)
{ 
	int i;
	u16i sround[8] ;
	sround[0]= SWAP16( *((u16i *) cp));
	sround[1]= SWAP16( *((u16i *) (cp+2)));
	sround[2]= SWAP16( *((u16i *) (cp+4)));
	sround[3]= SWAP16( *((u16i *) (cp+6))); 
	sround[4]= SWAP16(  *((u16i *) (cp+8)));
	sround[5]= SWAP16( *((u16i *) (cp+10)));
	sround[6]= SWAP16( *((u16i *) (cp+12)));
	sround[7]= SWAP16( *((u16i *) (cp+14)));		

	for(  i=0;i<round;i++) 
		SingleRoundRainDrop128256(sround, (u16i *)(rk+i*8));

	*((u16i *) out)= SWAP16(sround[4] );
	*((u16i *) (out+2))= SWAP16( sround[5]);
	*((u16i *) (out+4))= SWAP16( sround[6]  );
	*((u16i *) (out+6))= SWAP16( sround[7]);   
	*((u16i *) (out+8))= SWAP16(sround[0] );
	*((u16i *) (out+10))= SWAP16( sround[1]);
	*((u16i *) (out+12))= SWAP16( sround[2]  );
	*((u16i *) (out+14))= SWAP16( sround[3]);    

} 
