/*
 ܺĺ  ·ʵ
*/
#include "RainDrop256256_coreE.h"

static  const unsigned char _C_ALIGN16(Lbswap_maskB[16]) = { 0,1,8,9,4,5,12,13,2,3,10,11,6,7,14,15 };
static  const unsigned char _C_ALIGN16(Lbswap_maskF[16]) = { 0,2,4,6,8,10,12,14,1,3,5,7,9,11,13,15 };
static  const unsigned char _C_ALIGN16(RLbswap_mask[16]) = { 12,13,14,15, 8,9,10,11, 4,5,6,7,0,1,2,3 };
static  const unsigned char _C_ALIGN16(RLbswap_mask0[16]) = { 1,	3,	5,	7,9,	11,	13,	15,	0,	2,	4,	6,8,	10,	12,	14, };
static  const unsigned char _C_ALIGN16(LbRound0_mask[16]) = { 15, 7, 1,  2,  3,  4,  5, 6,  0  ,8, 9,  10, 11, 12, 13, 14, };
static  const unsigned char _C_ALIGN16(LbRound1_mask[16]) = { 14,6,7, 1,  2,  3,  4,  5, 15,  0,8, 9,  10, 11, 12, 13, };
static  const unsigned char _C_ALIGN16(lb_mask0[16]) = { 0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1, };
static  const unsigned char _C_ALIGN16(lb_mask1[16]) = { 2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3, };
static  const unsigned char _C_ALIGN16(lb_mask2[16]) = { 4,5,4,5,4,5,4,5,4,5,4,5,4,5,4,5, };
static  const unsigned char _C_ALIGN16(lb_mask3[16]) = { 6,7,6,7,6,7,6,7,6,7,6,7,6,7,6,7, };
static  const unsigned char _C_ALIGN16(lb_mask4[16]) = { 8,9,8,9,8,9,8,9,8,9,8,9,8,9,8,9, };
static  const unsigned char _C_ALIGN16(lb_mask5[16]) = { 10,11,10,11,10,11,10,11,10,11,10,11,10,11,10,11, };
static  const unsigned char _C_ALIGN16(lb_mask6[16]) = { 12,13,12,13,12,13,12,13,12,13,12,13,12,13,12,13, };
static  const unsigned char _C_ALIGN16(lb_mask7[16]) = { 14,15,14,15,14,15,14,15,14,15,14,15,14,15,14,15, };
static  const unsigned char _C_ALIGN16(Lbswap_maskA[16]) = { 15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0, };
static  const u32i  _C_ALIGN16(Lbswap_mask0[4]) = { 0,0,0,0xFC000000, };
static  const u64i  _C_ALIGN16(Lbswap_mask2[2]) = { 0,0x000fc001F8000000, };
static  const u64i  _C_ALIGN16(Lbswap_mask3[2]) = { 0x07F0000000000000,0x000FE001FC003F80, };
static  const u64i  _C_ALIGN16(Lbswap_mask4[2]) = { 0x03800070000E0000,0x0000000000001C00, };
static  const u64i  _C_ALIGN16(Lbswap_mask5[2]) = { 0,0xfc001f8003F00000, };
static  const u64i  _C_ALIGN16(Lbswap_mask6[2]) = { 0x000000000007e000,0, };



void RainDropGenRK_256_256_ENC(u8i * Rk, const u8i * K)
{
	__m128i A, B, C, D, E, F, G, H;
	__m128i *RRk = (__m128i *)Rk;
	u32i i;
	const __m128i MSK = _mm_load_si128((__m128i*) RLbswap_mask);
	__m128i MASK0 = _mm_load_si128((__m128i*) Lbswap_mask0);
	__m128i MASK2 = _mm_load_si128((__m128i*) Lbswap_mask2);
	__m128i MASK3 = _mm_load_si128((__m128i*) Lbswap_mask3);
	__m128i MASK4 = _mm_load_si128((__m128i*) Lbswap_mask4);
	__m128i MASK5 = _mm_load_si128((__m128i*) Lbswap_mask5);
	__m128i MASK6 = _mm_load_si128((__m128i*) Lbswap_mask6);
	const __m128i all0 = _mm_xor_si128(MSK, MSK);
	A = _mm_shuffle_epi8(_mm_loadu_si128((__m128i*)K), _mm_load_si128((__m128i*) Lbswap_maskA));
	B = _mm_shuffle_epi8(_mm_loadu_si128((__m128i*)(K + 16)), _mm_load_si128((__m128i*) Lbswap_maskA)); 
		*RRk = _mm_shuffle_epi8(A, MSK); RRk++;
		for (i = 1; i < RoundRainDrop256256; i++)
		{
			H = _mm_insert_epi32(all0, i, 1);
			A = _mm_xor_si128(A, H);
			Fun_D_SimdA(A, B, C, D, E, F, G, H);
			*RRk = _mm_shuffle_epi8(A, MSK); RRk++;
		}
}



#define  Sbox79A(l2) \
	t0= (l2<<1)& 0xFDFEFDFE;\
	t1= (l2>>6)& 0x02000200;\
	t4= (l2>>8)& 0x00010001;\
	t2= (l2<<2)& 0xF9FCF9FC;\
	t3= (l2>>5)& 0x06000600;\
	t5= (l2>>7)& 0x00030003;\
	l2=  l2^((~(t0|t1|t4 ))&(t2|t3|t5)); 

 


void SingleRoundRainDrop256256T(u32i *in, u32i *inb, u32i *rk)
{
	u32i l0, l1, l2, l3;
	u32i k0, k1, k2, k3;
	u32i t0, t1, t2, t3, t4, t5;

	l0 = (*in);
	l1 = *(in + 1);
	l2 = *(in + 2);
	l3 = *(in + 3);
	Sbox79A(l0);
	Sbox79A(l1);
	Sbox79A(l2);
	Sbox79A(l3);

	k0 = l1 ^ l3;
	k1 = ROTL32(l2^l3, 12);
	k2 = ROTL32(l0, 14);
	k3 = ROTL32(l0^l1, 24);
	(*inb) ^= k0 ^ ((*(rk)));
	*(inb + 1) ^= k1 ^ ((*(rk + 1)));
	*(inb + 2) ^= k2 ^ ((*(rk + 2)));
	*(inb + 3) ^= k3 ^ ((*(rk + 3)));
} 

void  RainDrop256256EncDataS(u8i *out, u8i *cp, u8i *rk)
{
	int i;
	u32i sround256[8];
	sround256[0] = SWAP32(*((u32i *)cp));
	sround256[1] = SWAP32(*((u32i *)(cp + 4)));
	sround256[2] = SWAP32(*((u32i *)(cp + 8)));
	sround256[3] = SWAP32(*((u32i *)(cp + 12)));
	sround256[4] = SWAP32(*((u32i *)(cp + 16)));
	sround256[5] = SWAP32(*((u32i *)(cp + 20)));
	sround256[6] = SWAP32(*((u32i *)(cp + 24)));
	sround256[7] = SWAP32(*((u32i *)(cp + 28)));

	for (i = 0; i < RoundRainDrop256256; i += 2)
	{
		SingleRoundRainDrop256256T(sround256, sround256 + 4, (u32i *)(rk + i * 16));
		SingleRoundRainDrop256256T(sround256 + 4, sround256, (u32i *)(rk + i * 16 + 16));

	}

	*((u32i *)out) = SWAP32(sround256[4]);
	*((u32i *)(out + 4)) = SWAP32(sround256[5]);
	*((u32i *)(out + 8)) = SWAP32(sround256[6]);
	*((u32i *)(out + 12)) = SWAP32(sround256[7]);
	*((u32i *)(out + 16)) = SWAP32(sround256[0]);
	*((u32i *)(out + 20)) = SWAP32(sround256[1]);
	*((u32i *)(out + 24)) = SWAP32(sround256[2]);
	*((u32i *)(out + 28)) = SWAP32(sround256[3]);

}

