#ifndef _H_RAINDROPCRYTYPE_
#define _H_RAINDROPCRYTYPE_

#include <stdio.h>
#include <string.h> 
#include <immintrin.h>
#include <stdint.h> 

#define Dirt_ENC 0
#define Dirt_DEC 1

#define LONGTEXTLEN (2*1024*1024)

#ifndef RoundRainDrop128128
#define RoundRainDrop128128  60
#endif

#ifndef RoundRainDrop128256
#define RoundRainDrop128256 80
#endif

#ifndef RoundRainDrop256256
#define RoundRainDrop256256  100
#endif  



#ifndef u8i
#define u8i unsigned char
#endif

#ifndef u16i
#define u16i uint16_t
#endif

#ifndef u32i
#define u32i uint32_t 
#endif

#ifndef u64i
#define u64i  uint64_t
#endif

#ifndef u128i   
#define u128i __m128i  
#endif


#ifdef  __GNUC__
#define _C_ALIGN(n, A)  A __attribute__ ((aligned (n)))
#elif _MSC_VER 
#define _C_ALIGN(n, A)  __declspec( align(n) ) A
#endif

#define _C_ALIGN16(A) _C_ALIGN(16,A)
#define _C_ALIGN32(A) _C_ALIGN(32,A)

#define  Sbox(l2) \
	t0= (l2<<1)& 0xFDFEFDFE;\
	t1= (l2>>6)& 0x02000200;\
	t4= (l2>>8)& 0x00010001;\
	t2= (l2<<2)& 0xF9FCF9FC;\
	t3= (l2>>5)& 0x06000600;\
	t5= (l2>>7)& 0x00030003;\
	l2=  l2^((~(t0|t1|t4 ))&(t2|t3|t5)); 



#define Fun_B(T,b,a,tmp)\
	T##7^= (T##0>>10);\
	tmp=T##7<<b;\
	T##6^=(T##1>>15);\
	T##7=(T##7>>a)|(T##6<<b);\
	T##5^=(T##2>>15);\
	T##6=(T##6>>a)|(T##5<<b);\
	T##5=(T##5>>a)|(T##4<<b);\
	T##4=(T##4>>a)|(T##3<<b);\
	T##3=(T##3>>a)|(T##2<<b);\
	T##2=(T##2>>a)|(T##1<<b);\
	T##1=(T##1>>a)|(T##0<<b);\
	T##0=(T##0>>a)|tmp; 

#define Fun_A(T,b,a,tmp)\
	T##7^= (T##1>>25);\
	tmp=T##7<<b;\
	T##6^=(T##0>>26);\
	T##7=(T##7>>a)|(T##6<<b);\
	T##5^=(T##3<<29);\
	T##6=(T##6>>a)|(T##5<<b);\
	T##5=(T##5>>a)|(T##4<<b);\
	T##4=(T##4>>a)|(T##3<<b);\
	T##3=(T##3>>a)|(T##2<<b);\
	T##2=(T##2>>a)|(T##1<<b);\
	T##1=(T##1>>a)|(T##0<<b);\
	T##0=(T##0>>a)|tmp;


/******************************
swap   rotate
********************************/
#define ROTL4(v, n) \
	(((v) << (n)) | ((v) >> (4 - (n)))) 

#define ROTL8(v, n) \
	((u8i)((v) << (n)) | ((v) >> (8 - (n)))) 

#define ROTL16(v, n) \
	((u16i)((v) << (n)) | ((v) >> (16 - (n)))) 

#define ROTR16(v, n) \
	((u16i)((v) >> (n)) | ((v) << (16 - (n))))   

#define SWAP16(v)\
	ROTL16(v, 8)

#define ROTL32(v, n) \
	((u32i)((v) << (n)) | ((v) >> (32 - (n))))

#define ROTR32(v, n) \
	((u32i)((v) >> (n)) | ((v) <<(32 - (n))))

#define SWAP32(v) \
	((ROTL32(v,  8) & (u32i)(0x00FF00FF)) | \
	(ROTL32(v, 24) & (u32i)(0xFF00FF00))) 

#define SWAP64(v) \
	(((u64i)SWAP32((u32i)(v)) << 32) | (u64i)SWAP32((u32i)(v >> 32)))


#define ROTL64(v, n) \
	((u64i)((v) << (n)) | ((v) >> (64 - (n))))


#define ROTL128(out,A,n, C,B)\
	B=_mm_srli_epi64(A,n);\
	C=_mm_slli_epi64(A,64-n);\
	C= _mm_shuffle_epi32(C,0x4e);\
	out= _mm_xor_si128(B,C); 

#define ROTR128(out,A,n, C,B)\
	B=_mm_slli_epi64(A,n);\
	C=_mm_srli_epi64(A,64-n);\
	C= _mm_shuffle_epi32(C,0x4e);\
	out= _mm_xor_si128(B,C);

#define Fun_D_SimdA(A,B,C,D,E,F,G,H)\
	C= _mm_alignr_epi8(B,A,9);\
	D= _mm_alignr_epi8(A,B,9);\
	E= _mm_slli_epi64(C,60);\
	F= _mm_slli_epi64(D,60);\
	G= _mm_srli_epi64(C,4);\
	H= _mm_srli_epi64(D,4);\
	C= _mm_alignr_epi8(F,E,8);\
	D= _mm_alignr_epi8(E,F,8);\
	C= _mm_or_si128(G,C);\
	D= _mm_or_si128(H,D);\
	C= _mm_xor_si128(C, _mm_and_si128(A,MASK0));\
	F= _mm_slli_epi64(A,2);\
	H= _mm_xor_si128(C, _mm_and_si128(F,MASK2));\
	E= _mm_srli_epi64(B,38);\
	F= _mm_srli_epi64(A,38);\
	G= _mm_slli_epi64(C,38);\
	E=_mm_xor_si128(E,B);\
	E= _mm_and_si128(E,MASK6);\
	D= _mm_xor_si128(E,D); \
	G= _mm_or_si128(G,F); \
	G= _mm_and_si128(G, MASK5 ); \
	G= _mm_xor_si128(G,H);\
	C= _mm_alignr_epi8(B,A,5);\
	H= _mm_alignr_epi8(A,A,14);\
	H= _mm_slli_epi64(H,1);\
	H= _mm_and_si128(H, MASK4);\
	B= _mm_xor_si128(H,D); \
	E= _mm_slli_epi64(C,3); \
	E= _mm_and_si128(E,MASK3);\
	A= _mm_xor_si128(G,E); 


#endif